OUTPUT_FORMAT("elf32-h8300")
OUTPUT_ARCH(h8300s)
ENTRY("_start")
MEMORY
{
	vectors(r)   : o = 0x000000, l = 0x000200
	rom(rx)      : o = 0x000200, l = (0x20000-0x600-0x200)
	ram2(rwx)    : o = 0xffec00, l = (0x1000-0x100)
	stack1(rw)   : o = 0xfffbfc, l = 0x000004
}
SECTIONS 				
{
.vectors : { *(.vect) }  > vectors 
/* text : program code */					
.text : {
	*(.text)		
	*(.text.*)
	*(.rodata)
	___ctors = . ;
	*(.ctors)
	___ctors_end = . ;
	___dtors = . ;
	*(.dtors)
	*(.rodata.*)
	*(.gnu.linkonce.t*)
	*(.gnu.linkonce.r*)
	*(.comment*)
	*(.strings)
	*(.gcc_except_table*)
	/* gcc_except_table :To save RAM, I moved gcc_except_table to ROM. */
	___dtors_end = . ;
   	 _etext = . ; 
	} > rom
.data : AT ( 0x1FA00  ){
	 _handler_begin = .;
	 *(.handler) 
	 *(handler) 
	 _handler_end = .;
/* data : Initialized variable */
	_data_begin = .;
	___data = . ;
	*(.data)
	*(.tiny)
	*(.gnu.linkonce.d*)
	*(.gnu.linkonce.s*)
	 _edata = .;
	_data_end = .;
	} > ram2
/* bss : Variable without initialization */
.bss  : {
	 _bss_begin = .;
	*(.bss)
	*(.gnu.linkonce.b*)
	*(COMMON)
	 _bss_end   = .;
	/* for stdlib :When the memory is used from the heap,this symbol(_end) is used. */
	_end = .;
	}  > ram2
.heap ALIGN(4) : {
	_heap_start = . ;
	_heap_end = (. + 0x580) ;
	} > ram2
.stack1 : {
	 _stack_internal = . ; 
	}  > stack1
}
