///////////////////////////////////////////////////////////
//  WriteRom.cpp
//  Implementation of the Class WriteRom
//  Created on:      29-4-2009 15:41:20
//  Original author: Ueno
///////////////////////////////////////////////////////////

#include "Application/EELTBootWriter/WriteRom.h"
#include "Common/BasicType/util.h"
#include "Common/BasicType/ValueToStringConverter.h"

using Application::EELTBootWriter::WriteRom;

WriteRom::WriteRom(Unit::CPUBoard::CPUBoard* pCPUBoard):m_pCPUBoard(pCPUBoard){}
WriteRom::~WriteRom(){}

bool WriteRom::check(const Common::BasicType::Bytes* command){
	bool bRet=false;
	if(command->size()>=1)
	{
		if( ((*command)[0]) =='S')
		{
			bRet=true;
		}
	}
	return bRet;
}


void WriteRom::execute(Unit::Communication::Com* com,Common::BasicType::Bytes* command){
	
	m_SFormat.init(command);
	switch(m_SFormat.getRecordFormat())
	{
		case Common::Util::SFormat::RF_S0 : 
			com->echoOff(); 
			Common::Util::SFormat::setNumberOfLine(0);
			Common::Util::SFormat::setReceiving(true);
			break;
		case Common::Util::SFormat::RF_S1 : 
		case Common::Util::SFormat::RF_S2 : 
		case Common::Util::SFormat::RF_S3 : 
			if(Common::Util::SFormat::getReceiving()==true)
			{
				program();
				// 1Kbytež뤿Ӥˣɽ
				if(Common::Util::SFormat::getNumberOfLine()%64==0)
				{

					Common::BasicType::Bytes* pMark=new Common::BasicType::Bytes(".");
					com->send(pMark,false);
				}
			}
			break;
		case Common::Util::SFormat::RF_S7 : 
		case Common::Util::SFormat::RF_S8 : 
		case Common::Util::SFormat::RF_S9 : 
			receiveEnd(com,".",NULL);
			com->echoOn();
			break;
		case Common::Util::SFormat::RF_CHECKSUM_ERROR : 
			receiveEnd(com,"** CheckSum Error **",command);
			break;
		case Common::Util::SFormat::RF_SIZE_ERROR : 
			receiveEnd(com,"** Size Error **",command);
			break;
		default : 
			receiveEnd(com,"** INVALID_SFORMAT **",command);
			break;
	}
	com->releaseReceptionBuffer(command);

}

void WriteRom::program()
{
	Common::TypeDef::UTwoByte i,size;
	Common::TypeDef::UFourByte addr;
	addr=m_SFormat.getStartAddress();
	size=m_SFormat.size();
	for(i=0; i<size; i++)
	{
		// ROMƬΥեåȤΥɥ쥹ꤷƽ񤭹
		m_pCPUBoard->programOneByte(addr+i,m_SFormat.getAt(i));
	}
}

void WriteRom::receiveEnd(Unit::Communication::Com* com,char *msg,Common::BasicType::Bytes* command)
{
	Common::BasicType::Bytes* pMark;
	if(command != NULL)
	{
		pMark=new Common::BasicType::Bytes(*command);
	}
	else
	{
		pMark=new Common::BasicType::Bytes();
	}
	pMark->push_back(msg,strLen(msg));
	com->send(pMark,true);
	Common::Util::SFormat::setReceiving(false);
}
